//
// Copyright (C) 2008 Institut fuer Telematik, Universitaet Karlsruhe (TH)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//

#ifndef __PATRICIA_H
#define __PATRICIA_H

#include <cassert>
#include "packets/IpPacket.h"

class Patricia {

public:
	Patricia		();
	~Patricia		();

	typedef struct _NODE {
		bool			value;
		short			count;			
		PIP_ADDR		networkip;		// the hashed network-part-ip 
		struct _NODE*	left;			// 0-child
		struct _NODE*	right;			// 1-child

		_NODE () {
			left		= NULL;
			right		= NULL;	
			networkip	= NULL;
		}

		~_NODE () {
			delete left;
			delete right;
			delete networkip;
		}

	} NODE, *PNODE;


	void			insert				(IP_ADDR addr, unsigned short mask);
	PNODE			find				(IP_ADDR addr, PNODE tree = NULL, unsigned short cnt = 0);
	
private:

	PNODE			root;

};

#endif // __PATRICIA_H

